QGIS Application - Bug report #14844
Oblique Mercator projection hanging when rendering map
2016-05-19 11:38 AM - Matt Dallaire

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Projection Support

Affected QGIS version:2.14.3 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 22797
Description

Hi,

My custom CRS' that use oblique mercator no longer render properly in 2.14. Some layers are rotated properly, others are not, and others
are missing. Also, rendering would normally take 2-5 seconds in v2.10 but now it can take 10s of minutes - making them unusable.
"Normal" CRS' provided by the program work fine. Here's one of my CRS' for example:

+proj=omerc +lat_0=53.155728 +lonc=-117.171755 +alpha=-44.25 +gamma=0 +k_0=1.00064458 +x_0=0 +y_0=0+€llps=GRS80
+towgs84=0,0,0,0,0,0,0 +units=m +no_defs

And another from http://gis.stackexchange.com/questions/83861/using-customized-coordinate-system-for-archaeological-site-data that

also no longer works:
+proj=omerc +lat_0=51.4 +lonc=7 +alpha=-10 +k=1 +x_0=0 +y_0=0 +gamma=0 +ellps=WGS84 +towgs84=0,0,0,0,0,0,0 +units=m
+no_defs

Quickly switching between my custom CRS and NAD83 also causes QGIS to freeze and eventually a force quit.

Associated revisions

Revision 85128¢54 - 2016-06-20 11:30 AM - Even Rouault
QgsCoordinateReferenceSystem::setProj4String(): harden validation
OSRImportFromProj4() may accept strings that are not valid proj.4 strings,

e.g if they lack a +ellps parameter, it will automatically add +ellps=WGS84, but as
we use the original mProj4 with QgsCoordinateTransform, it will fail to initialize

S0 better detect it now.

Fixes #14844

Revision 7b0bec7b - 2016-06-20 11:35 AM - Even Rouault
QgsCoordinateReferenceSystem::setProj4String(): harden validation
OSRImportFromProj4() may accept strings that are not valid proj.4 strings,

e.g if they lack a +ellps parameter, it will automatically add +ellps=WGS84, but as

we use the original mProj4 with QgsCoordinateTransform, it will fail to initialize
so better detect it now.
http://gis.stackexchange.com/questions/83861/using-customized-coordinate-system-for-archaeological-site-data

(cherry-picked and adapted from master 85128c54191cfedeaee04ca9c4ac0341ab8f5088)

Fixes #14844

History

#1 - 2016-05-23 12:58 PM - Giovanni Manghi
- Category set to Projection Support
- Status changed from Open to Feedback

Could you please attach sample project with data?

#2 - 2016-05-23 01:54 PM - Giovanni Manghi

- Crashes QGIS or corrupts data changed from No to Yes

#3 - 2016-05-24 10:31 AM - Matt Dallaire

- File CV.zip added

Sample project attached. Used QConsolidate plugin. Thanks for your attention.

#4 - 2016-05-24 12:42 PM - Giovanni Manghi

Thanks or the project:

I'm opening it in QGIS 2.14.3 and | notice that is missing giute a lot of layers.
Not sure if it is for this reason, bt the project opens fine (with the provided layers), navigation zoom in/out is also ok, styling, labels, etc.

Could you please describe what would be the issue in the provided project?

Thanks!

#5 - 2016-05-24 01:14 PM - Matt Dallaire

| removed all the large layers due to the 5MB file upload restriction.

Change the project CRS to:

+proj=omerc +lat_0=53.155728 +lonc=-117.171755 +alpha=-44.25 +gamma=0 +k_0=1.00064458 +x_0=0 +y_0=0+ellps=GRS80
+towgs84=0,0,0,0,0,0,0 +units=m +no_defs

Notice the layers are now being rendered in varying ways. For example, "CVM Grid" (ESPG:26911) does not change position or rotate, "083C_water_c_I"
(ESPG:4269) moves toward the origin, and "RT Mine Footprint" (custom projection) actually is the only layer that projects correctly - probably because it
matches the above CRS string. It almost seems like OTF projection is not working, in my opinion.

This was not an issue in recent previous releases.

Cheers,
#6 - 2016-05-24 01:18 PM - Giovanni Manghi

- Status changed from Feedback to Open

- Crashes QGIS or corrupts data changed from Yes to No
- Affected QGIS version changed from 2.14.2 to 2.14.3

- Priority changed from High to Severe/Regression

| see. Tagging as regression.

#7 - 2016-06-19 02:17 PM - Even Rouault

The issue with "+proj=omerc +lat_0=53.155728 +lonc=-117.171755 +alpha=-44.25 +gamma=0 +k_0=1.00064458 +x_0=0 +y_0=0+¢€llps=GRS80

+towgs84=0,0,0,0,0,0,0 +units=m +no_defs" is a missing space before +ellps. Addressed by https://github.com/qgis/QGIS/pull/3217

| didn't notice issues with "+proj=omerc +lat_0=51.4 +lonc=7 +alpha=-10 +k=1 +x_0=0 +y_0=0 +gamma=0 +ellps=WGS84 +towgs84=0,0,0,0,0,0,0

+Units=m +no_defs"

#8 - 2016-06-20 02:30 AM - Even Rouault
- Status changed from Open to Closed

Fixed in changeset commit:"85128c54191cfedeaee04ca9c4ac0341ab8f5088".

#9 - 2016-06-20 02:38 AM - Even Rouault
- Resolution set to fixed/implemented
- Target version changed from Future Release - High Priority to Version 2.14

Files
CV.zip 1.05 MB 2016-05-24 Matt Dallaire
2025-04-27 3/3


https://github.com/qgis/QGIS/pull/3217

